/***************************************************************************
                          wadfile.h  -  description
                             -------------------
    begin                : Wed Jul 26 2000
    copyright            : (C) 2000 by Simon E. Reichelt
    email                : s.reichelt@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef WADFILE_H
#define WADFILE_H 1

#define WAD2 1
#define WAD3 2

#define MIPTEX(wad_t) ((wad_t == WAD2) ? 68 : 67)


typedef struct
{
	char		identification[4];
	int			numlumps;
	int			infotableofs;
} wadinfo_t;


typedef struct
{
	int			filepos;
	int			disksize;
	int			size;
	char		type;
	char		compression;
	char		pad1, pad2;
	char		name[16];
} lumpinfo_t;


typedef struct
{
	char		name[16];
	unsigned	width, height;
	unsigned	offsets[4];
} miptex_t;


typedef unsigned char byte_t;


extern int wad_type;


int CheckMemory(void *mem_p);

FILE *OpenFile(char name[], char mode[]);

int CheckFileType(FILE *w_file);

byte_t *LoadFileFromDisk(FILE *file_p);

void LoadWadFile(GtkWidget *widget, char f_name[]);

#endif